<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="100px"
    >
      <el-row>
        <el-form-item label="挂锁编码" prop="lockCode">
          <el-input
            v-model="queryParams.lockCode"
            placeholder="请输入挂锁编码"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item label="挂锁名称" prop="lockName">
          <el-input
            v-model="queryParams.lockName"
            placeholder="请输入挂锁名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item style="margin-left: 20px">
          <el-button
            v-no-more-click
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索
          </el-button>
          <el-button
            v-no-more-click
            icon="el-icon-refresh"
            size="mini"
            @click="resetQuery"
            >重置
          </el-button>
        </el-form-item>
      </el-row>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-no-more-click
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['mes:hw:plk:add']"
          >新增
        </el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button
          v-no-more-click
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['mes:hw:plk:batchremove']"
          >批量删除
        </el-button>
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="repairList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column
        label="挂锁编码"
        width="150px"
        align="center"
        prop="lockCode"
      />
      <el-table-column
        label="挂锁名称"
        width="200px"
        align="center"
        prop="lockName"
      />
      <el-table-column
        label="挂锁NFC"
        width="180px"
        align="center"
        prop="lockNfc"
        :show-overflow-tooltip="true"
      />

      <el-table-column label="所属硬件" align="center" prop="hardwareName" />
      <el-table-column label="挂锁类型" align="center" prop="lockTypeName" />
      <el-table-column label="挂锁型号" align="center" prop="lockSpec" />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        width="180"
      >
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>

      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['mes:hw:plk:edit']"
            >编辑
          </el-button>
          <el-button
            v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['mes:hw:plk:remove']"
            >删除
          </el-button>
          <!--          <el-button v-no-more-click size="mini" type="text">预览</el-button>-->
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />

    <!-- 添加或修改设备维修单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="450px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="所属硬件" prop="hardwareId">
          <el-select
            v-model="form.hardwareId"
            placeholder="请选择所属硬件"
            clearable
            style="width: 100%"
          >
            <el-option
              v-for="dict in this.hardWareList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="挂锁类型" prop="lockTypeId">
          <!-- <el-input v-model="form.lockTypeId" placeholder="请输入挂锁类型Id" /> -->
          <treeselect
            v-model="form.lockTypeId"
            :options="lockTypeOption"
            placeholder="请选择挂锁类型"
          />
        </el-form-item>
        <el-row>
          <el-col :span="15">
            <el-form-item label="挂锁编码" prop="lockCode">
              <el-input
                v-model="form.lockCode"
                placeholder="请输入挂锁编码"
                style="width: 100%"
              />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label-width="80">
              <el-switch
                v-model="autoGenFlag"
                active-color="#13ce66"
                active-text="自动生成"
                @change="handleAutoGenChange(autoGenFlag)"
              >
              </el-switch>
            </el-form-item>
          </el-col>
        </el-row>

        <el-form-item label="挂锁名称" prop="lockName">
          <el-input v-model="form.lockName" placeholder="请输入挂锁名称" />
        </el-form-item>
        <el-form-item label="挂锁NFC" prop="lockNfc">
          <el-input
            v-model="form.lockNfc"
            placeholder="请输入挂锁Nfc"
          />
        </el-form-item>
        <el-form-item label="挂锁型号" prop="lockSpec">
          <el-input
            v-model="form.lockSpec"
            placeholder="请输入挂锁型号"

          />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button v-no-more-click type="primary" @click="submitForm"
          >确 定</el-button
        >
        <el-button v-no-more-click @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listPadLockAPI,
  addPadLockAPI,
  updatePadLockAPI,
  delPadLockAPI,
  getPadLockInfoAPI,
} from "@/api/mes/padLocks/padLocks";
import { listHardware } from "@/api/mes/hw/hardwareinfo";
import { listPadLockTypeAPI } from "@/api/mes/padLockType/padLockType";
import { genCode } from "@/api/system/autocode/rule";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
// import { listHanrwareType } from "@/api/mes/hw/hadrwareType";

export default {
  name: "lock",
  dicts: ["hardware_status"],
  components: { Treeselect },
  data() {
    return {
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      codes: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 设备维修单表格数据
      repairList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      createTime: "",
      queryParams: {
        current: 1,
        size: 10,
        lockCode: null,
        lockName: null,
        lockNfc: null,
        lockTypeId: null,
      },
      hardWareList: [],
      queryhwParams: {
        current: 1,
        size: -1,
      },

      // 表单参数
      form: {
        hardwareId: null,
        lockTypeId: null,
      },
      // 表单校验
      rules: {
        lockCode: [
          { required: true, message: "挂锁编码不能为空", trigger: "blur" },
        ],
        lockName: [
          { required: true, message: "挂锁名称不能为空", trigger: "blur" },
        ],
        lockNfc: [
          { required: true, message: "挂锁NFC不能为空", trigger: "blur" },
        ],
      },
      // 日期选择
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      // 新增状态
      EditId: 0, //修改判断
      lockTypeOption: [], //挂锁类型
      flatlockTypeOption: [], // 用于快速查找
    };
  },
  created() {
    this.getList();
    this.getHardWare();
    this.getHardwareTypeList();
    this.convertToTreeStructure();
  },
  methods: {
    // 硬件信息
    getHardWare() {
      listHardware(this.queryhwParams).then((response) => {
        this.hardWareList = response.data.records.map((item) => {
          return {
            value: item.id,
            label: item.hardwareName,
          };
        });

        // console.log(response, this.hardWareList, "获取硬件信息");
      });
    },
    //自动生成编码
    handleAutoGenChange(autoGenFlag) {
      if (autoGenFlag) {
        genCode("LOCK_CODE").then((response) => {
          this.form.lockCode = response;
          // console.log(response, this.form.lockCode, "lockCode");
        });
      } else {
        this.form.lockCode = null;
      }
    },
    /** 查询列表 */
    getList() {
      this.loading = true;

      // 锁具机构数据
      listPadLockAPI(this.queryParams).then((response) => {
        this.repairList = response.data.records;
        this.total = response.data.total;
        this.loading = false;
      });
    },

    // 获取硬件类型-所有
    getHardwareTypeList() {
      const data = {
        current: 1,
        size: 10000,
      };
      listPadLockTypeAPI(data).then((response) => {
        // console.log(response, "Type");
        this.flatlockTypeOption = response.data.records; // 保存扁平数据
        this.lockTypeOption = this.convertToTreeStructure(
          response.data.records
        );
      });
    },

    // 将扁平数据转换为树形结构
    convertToTreeStructure(data) {
      const map = {};
      const tree = [];

      // console.log(data, "convertToTreeStructure-data");

      data.forEach((item) => {
        map[item.lockTypeId] = {
          id: item.lockTypeId,
          label: item.lockTypeName,
          children: [],
        };
      });

      data.forEach((item) => {
        const node = map[item.lockTypeId];
        if (item.parentTypeId === "0") {
          tree.push(node);
        } else {
          const parent = map[item.parentTypeId];
          if (parent) {
            parent.children.push(node);
          }
        }
      });

      return tree;
    },
    // 处理选择变化
    onSelectChange(selectedId) {
      this.form.lockTypeId = selectedId;

      // 查找对应的 hardwareTypeName
      const selectedOption = this.flatHardwareTypeOption.find(
        (option) => option.id === selectedId
      );
      if (selectedOption) {
        this.form.lockTypeName = selectedOption.lockTypeName;
      } else {
        // console.error("Selected ID not found:", selectedId);
      }

      // console.log("Selected ID:", selectedId);
      // console.log("Selected Name:", this.form.lockTypeName);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        lockName: null,
        lockCode: null,
        lockNfc: null,
        remark: null,
      };

      this.autoGenFlag = false;
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams.lockCode = "";
      this.queryParams.lockName = "";
      this.queryParams.lockId = "";
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.lockId);
      this.codes = selection.map((item) => item.lockCode);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.EditId = null;
      this.title = "新增挂锁信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.EditId = row.lockId || this.ids;
      getPadLockInfoAPI(this.EditId).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "编辑挂锁信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.EditId != null) {
            updatePadLockAPI(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            // console.log(this.form, "form");
            addPadLockAPI(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.EditId = null;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const repairIds = row.lockId || this.ids;
      const repairCodes = row.lockCode || this.codes;
      this.$modal
        .confirm('是否确认删除编码为"' + repairCodes + '"的数据项？')
        .then(function () {
          return delPadLockAPI(repairIds);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
  },
};
</script>
<style scoped>
.imgstatus {
  position: relative;
  top: 1px;
  left: 0px;
}

/deep/ .el-radio__inner {
  border-radius: 2px;
}

/deep/ .el-radio__input.is-checked .el-radio__inner::after {
  content: "";
  width: 8px;
  height: 3px;
  border: 1px solid white;
  border-top: transparent;
  border-right: transparent;
  text-align: center;
  display: block;
  position: absolute;
  top: 3px;
  left: 2px;
  transform: rotate(-45deg);
  border-radius: 0pc;
  background: none;
}
</style>
